/**
 * plugin.js
 *
 * Copyright, Moxiecode Systems AB
 * Released under LGPL License.
 *
 * License: http://www.tinymce.com/license
 * Contributing: http://www.tinymce.com/contributing
 */

/*global tinymce:true */

tinymce.PluginManager.add('eqdkp_chars', function(editor) {
	
	function showDialog(folderList) {
		var win, data, dom = editor.dom, imgElm = editor.selection.getNode();
		var width, height, imageListCtrl;
		
		data = {
			char: 0,
		};
		
		function buildCharacterList(relValue) {
			var raidItems = [];

			raidItems.push({
				text: "None",
				value: 0,
				selected: 0,
			});
			
			tinymce.each(folderList, function(rel) {
				raidItems.push({
					text: rel.text || rel.title,
					value: rel.value,
					selected: relValue === rel.value
				});
			});

			return raidItems;
		}	

		win = editor.windowManager.open({
			title: "EQdkp Plus Characters",
			data: data,
			body: [
				{name: 'char', type: 'listbox', label: 'Select Character', values: buildCharacterList(-1)},
			],
			onSubmit: function(e) {
				var data = e.data;
				
				if (data.char !== ''){
					editor.execCommand('mceInsertContent', false, '{{char::'+data.char+'}}');
				}

				
			}
		});
	}
	
	function prepareDialog(){
		jQuery.get(editor.baseURI.source+"/plugins/eqdkp_chars/get_chars.php"+mmocms_sid, function(retdata){
			if(retdata.status == 'ok'){
				var chars = [];
				
				jQuery.each(retdata.chars, function(key, value) {
					chars.push({
						text: value.name,
						value: value.id,
						selected: 0,
					});	
				});
								
				showDialog(chars);
			} else {
				alert('Error while reading character.');
			}
		}, "json");

	}

	editor.addButton('eqdkp_chars', {
		icon: 'users',
		tooltip: 'Insert EQdkp Plus Chars',
		onclick: prepareDialog,
	});

	editor.addMenuItem('eqdkp_chars', {
		icon: 'users',
		text: 'Insert EQdkp Plus Chars',
		onclick: prepareDialog,
		context: 'insert',
		prependToContext: true
	});
});