/**
 * plugin.js
 *
 * Copyright, Moxiecode Systems AB
 * Released under LGPL License.
 *
 * License: http://www.tinymce.com/license
 * Contributing: http://www.tinymce.com/contributing
 */

/*global tinymce:true */

tinymce.PluginManager.add('eqdkp_easyinsert', function(editor) {
	function showDialog() {
		var win, data, dom = editor.dom;
		var width, height, imageListCtrl;

		win = editor.windowManager.open({
			title: "Insert JavaScript",
			data: data,
			body: [
				{name: 'type', type: 'listbox', label: 'Select Type', values: [{text: 'Tabs', value: 'tabs'}, {text: 'Accordion', value: 'accordion'}, {text: 'Spoiler', value: 'spoiler'}, {text: 'Progressbar', value: 'progressbar'}]},
			],
			onSubmit: function(e) {
				var data = e.data;
				
				var random = "easyinsert_" + Math.floor((Math.random() * 10000) + 1);
				
				if (data.type == 'tabs'){
					editor.execCommand('mceInsertContent', false, '<div class="system-block2"><script type="text/javascript">$(document).ready(function(){ $(function() {$( "#tabs_'+random+'" ).tabs();}); })</script> <div id="tabs_'+random+'"><ul><li><a href="#tabs-'+random+'-1">Tab 1</a></li><li><a href="#tabs-'+random+'-2">Tab 2</a></li><li><a href="#tabs-'+random+'-3">Tab 3</a></li></ul><div id="tabs-'+random+'-1"><p>Content Tab 1</p></div><div id="tabs-'+random+'-2"><p>Content Tab 2</p></div><div id="tabs-'+random+'-3"><p>Content Tab 3</p></div></div></div><p>&nbsp;</p>');
				}
				
				if (data.type == 'accordion'){
					editor.execCommand('mceInsertContent', false, '<div class="system-block2"><script type="text/javascript">$(document).ready(function(){ $(function() { $( "#accordion_'+random+'" ).accordion(); }); })</script> <div id="accordion_'+random+'"><h3>Section 1</h3><div><p>Content Section 1</p></div><h3>Section 2</h3><div><p>Content Section 2</p></div><h3>Section 3</h3><div><p>Content Section 3</p></div></div></div><p>&nbsp;</p>');
				}
				
				if (data.type == 'spoiler'){
					editor.execCommand('mceInsertContent', false, '<div class="system-block2"><script type="text/javascript">$(document).ready(function(){ $("#spoiler_btn_'+random+'").parent().find(".spoiler_content").hide();  $("#spoiler_btn_'+random+'").on("click", function(){ $(this).parent().find(".spoiler_content").toggle(); if($(this).parent().find(".spoiler_content").is(":visible")){ $(this).html("Hide text"); } else { $(this).html("Show text");}})})</script><div class="spoiler_container"><button class="spoiler_button" id="spoiler_btn_'+random+'">Show text</button><div class="spoiler_content">Hidden Content</div></div></div><p>&nbsp;</p>');
				}
				
				if (data.type == 'progressbar'){
					editor.execCommand('mceInsertContent', false, '<div class="system-block2"><script type="text/javascript"> $(document).ready(function(){ $(function() { $( "#progressbar_'+random+'" ).progressbar({ value: 42 });});});</script>Progessbar Title<div id="progressbar_'+random+'"><div class="progress-label" style="position:absolute;left:50%;">Progressbar Label</div></div></div><p>&nbsp;</p>');
				}

			}
		});
	}

	editor.addMenuItem('eqdkp_easyinsert', {
		icon: '',
		text: 'Insert JavaScript',
		onclick: showDialog,
		context: 'insert',
		prependToContext: true
	});
});