/**
 * plugin.js
 *
 * Copyright, Moxiecode Systems AB
 * Released under LGPL License.
 *
 * License: http://www.tinymce.com/license
 * Contributing: http://www.tinymce.com/contributing
 */

/*global tinymce:true */

tinymce.PluginManager.add('eqdkp_filebrowser', function(editor) {
	function showDialog() {
		var win, data, dom = editor.dom, imgElm = editor.selection.getNode();
		
		var elfinder_url = mmocms_root_path+"libraries/elfinder/elfinder.php"+mmocms_sid;    // use an absolute path!
		var cmsURL = elfinder_url;
		if (cmsURL.indexOf("?") < 0) {
			//add the type as the only query parameter
			cmsURL = cmsURL + "?editor=tiny";
		}
		else {
			//add the type as an additional query parameter
			// (PHP session ID is now included if there is one at all)
			cmsURL = cmsURL + "&editor=tiny";
		}
		
		win = editor.windowManager.open({
			file : cmsURL,
			title : "File Browser",
			width : 900,
			height : 450,
			resizable : "yes",
			inline : "yes",  // This parameter only has an effect if you use the inlinepopups plugin!
			popup_css : false, // Disable TinyMCEs default popup CSS
			close_previous : "yes"
		});
	}

	editor.addButton('eqdkp_filebrowser', {
		icon: 'browse',
		tooltip: 'Filebrowser',
		onclick: showDialog,
	});

	editor.addMenuItem('eqdkp_filebrowser', {
		icon: 'browse',
		text: 'Filebrowser',
		onclick: showDialog,
		context: 'insert',
		prependToContext: true
	});
});