/**
 * plugin.js
 *
 * Copyright, Moxiecode Systems AB
 * Released under LGPL License.
 *
 * License: http://www.tinymce.com/license
 * Contributing: http://www.tinymce.com/contributing
 */

/*global tinymce:true */

tinymce.PluginManager.add('eqdkp_item', function(editor) {
	function showDialog() {
		var win, data, dom = editor.dom;
		var width, height, imageListCtrl;

		win = editor.windowManager.open({
			title: "Insert Item",
			data: data,
			body: [
				{name: 'item', type: 'textbox', label: 'Itemname',autofocus: true},
				{type: 'label', text: 'or'},
				{name: 'itemid', type: 'textbox', label: 'Item-ID'},
			],
			onSubmit: function(e) {
				var data = e.data;
				
				if (data.item !== ''){
					editor.execCommand('mceInsertContent', false, '{{item::'+data.item+'}}');
				}else if(data.itemid !== ''){
					editor.execCommand('mceInsertContent', false, '{{itemid::'+data.itemid+'}}');
				}
			}
		});
	}

	editor.addButton('eqdkp_item', {
		icon: 'gift',
		tooltip: 'Insert EQdkp Plus Item',
		onclick: showDialog,
	});

	editor.addMenuItem('eqdkp_item', {
		icon: 'gift',
		text: 'Insert EQdkp Plus Item',
		onclick: showDialog,
		context: 'insert',
		prependToContext: true
	});
});